#!/usr/bin/awk -f
# Copyright (C)2009..2017 @BABOLO http://www.babolo.ru/
# PKG = pgoblinclude
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: pleaf.awk,v 1.1 2017/04/02 11:07:33 babolo Exp $
#

BEGIN{
    r = 32767;
    e = -1;
}

{   c = 0;
    if  (r >= FNR) {
        sub("^.*/", "", n);
        if  (e >= 0) {
            if  (mode == 1) print e "	" t "	" n >> pleaf;
            else if (mode == 2) print e "	\\N	" n >> pleaf;
        }
        s = 0;
        f = 0;
        t = "";
    }
    r = FNR;
}

(/^[ 	]*#/ || /^[ 	]*$/ ) && !s {
    c = 1;
}

(s == 2) {
    print $0 > n;
}

(s == 1) {
    gsub("\\\\", "\\\\");
    gsub("	", "\\t");
    gsub("\b", "\\b");
    gsub("\f", "\\f");
    gsub("\n", "\\n");
    gsub("\r", "\\r");
    gsub("\v", "\\v");
    if  (f) t = t "\\n" $0; else t = $0;
    f++;
}

!c && !s {
    k = $1;
    e = -1;
    if  (mode == 1) {
        if  (k == "const") e = 0;
        if  (k == "eval" ) e = 2;
    } else if (mode == 2) {
        if  (k == "const") e = 1;
        if  (k == "eval" ) e = 3;
    }
    s = mode;
    n = FILENAME;
    sub("\.pleaf", "", n);
}

END{
    sub("^.*/", "", n);
    if  (e >= 0) {
        if  (mode == 1) print e "	" t "	" n >> pleaf;
        else if (mode == 2) print e "	\\N	" n >> pleaf;
}   }
